<!DOCTYPE html>
<html>
<head>
	<title>Momel</title>
	<meta charset="utf-8">
	<link rel="stylesheet" type="text/css" href="https://warriordudimanche.net/cdn/helium.css">
	<link rel="icon" type="image/svg" href="http://api.warriordudimanche.net/iconeleon/?i=fontawesome%20solid/th.svg&c=white">
	<style type="text/css">
		html{
			font-family: Arial Rounded MT Bold,Helvetica Rounded,Arial,sans-serif; 
			min-width: 320px;
			--base_color:270;
		}
		header{
			background:var(--theme_color);
			color:white;
			padding:2em;
		}
		header h1{
			font-size:32px;
			max-width: 1200px;
			margin:1em auto;
			padding-left:15px;
		}
		header img{
			height:28px;
			width:auto;
		}
		main{
			max-width: 1200px;
			margin:1em auto;
			padding:15px;
		}
			form>div{
				margin-top:15px;
			}
			label{
				display:block;
				font-size:16px;
			}
			input[type=text],textarea,
			input[type=text]:focus,textarea:focus
			{
				width:100%;
				padding:10px;
				font-size:1.3em;
				border-width: 2px;	
			}
			input[type=text]:focus,textarea:focus
			{
				color:var(--theme_color);
			}
			textarea{
				min-height:128px;
				resize:vertical;
				padding:10px;
				font-size:1.3em;
			}

			.icon{height:16px;width:auto;}
			form button{
				color:white;
			}
			div.right{
				display:flex;
				flex-direction: row-reverse;
			}
			form a.btn,form a.btn:hover{background: transparent;border: none}
			#render img{
				display:block;
				margin:auto;
				min-width:64px;
				min-height: 64px;
				width:100%;
				height: auto;
			}
			input[type="radio"]+label{
				display:block;
				width:100%;
				height:48px;
				border-radius: 3px;
				border: 1px solid transparent;
				opacity:0.8;
			}
			input:disabled+label{
				opacity:0.1;
			}
			input[type="radio"]:checked+label{
				opacity:1;
				border-color:rgba(0,0,0,0.5);
			}
			input[type="radio"]+label:hover{
				opacity:1;
				cursor: pointer;
			}
			input[type="radio"]:disabled+label:hover{
				opacity:0.1;
				cursor: initial;
			}
			header small{
				display:block;
				text-align: right;
			}
	</style>
</head>
<body>
<header>
	<h1><img src="http://api.warriordudimanche.net/iconeleon/?i=fontawesome%20solid/th.svg&c=white"/> Momel</h1>
	<small>v<?php echo VERSION ?></small>
</header>
<main>
	<form action="" method="get" target="_BLANK">
		<input type="hidden" name="force" value="true">
		<div>
			<label>
				titre
			</label>
			<input type="text" name="title" />
		</div>
		<div>
			<label>
				*mots séparés par des virgules (pas d'accents) 
			</label>
			<textarea name="mots" required="true" ></textarea>
		</div>
		<div>
			<label>
				taille de la grille
			</label>
			<select name="size">
			<?php
				for ($i=5; $i <= 40; $i+=5) { 
					if ($i=='15'){
						$selected=' selected ';
					}else{
						$selected='';
					}
					echo "<option value='$i' $selected>$i</option>";
				}
			?>
			</select>
		</div>
		<div>
			<label>
				<input type="checkbox" name="horizontal">Horizontal seulement
			</label>
		</div>
		<div>
			<label>
				<input type="checkbox" name="list" onclick="toggle(this)"><span>Ajouter la liste</span><input type="text" id="list" name="list" placeholder="Laisser vide pour joindre la liste de mots ci-dessus" disabled/>

			</label>
		</div>


		
			
		<div class="right">				
			<button  ><img class="icon" src="http://api.warriordudimanche.net/iconeleon/?i=fontawesome%20solid/cloud-download-alt.svg&c=white" title="Télécharger cette grille"/> Télécharger</button>
		</div>

	</form>


</main>
<script type="text/javascript">
	function toggle(me){

		obj=document.getElementById('list');
		if (me.checked){obj.removeAttribute('disabled');console.log('oui')}
			else{obj.setAttribute('disabled',true);console.log('non')}
	}
</script>
</body>
</html>