<?php
########################################
#                                      #
# █     █  ████  █     █ ██████ ████   #
# ██   ██ ██  ██ ██   ██ ██      ██    #
# ███ ███ ██  ██ ███ ███ ██      ██    #
# ███████ ██  ██ ███████ █████   ██    #
# ██ █ ██ ██  ██ ██ █ ██ ██      ██    #
# ██   ██ ██  ██ ██   ██ ██      ██ ██ #
# ██   ██  ████  ██   ██ ██████ ██████ #
#                                      #
######################################## 

########################
#                      #
#  ▒▒▒▒  ▒   ▒▒  ▒▒▒▒  #
#   ▒▒   ▒▒  ▒▒   ▒▒   #
#   ▒▒   ▒▒▒ ▒▒   ▒▒   #
#   ▒▒   ▒▒▒▒▒▒   ▒▒   #
#   ▒▒   ▒▒ ▒▒▒   ▒▒   #
#   ▒▒   ▒▒  ▒▒   ▒▒   #
#  ▒▒▒▒  ▒▒   ▒  ▒▒▒▒  #
#                      #
########################
include('class_grid.php');
include('zip_class.php');
define('FONTE','courrier');
define('FONTE_TEXTE','Sunday');
define('TAILLE_FONTE',32);
define('TAILLE_MIN_GRILLE',15);
define('VERSION','1.4');


##################################################################
#                                                                #
# ▒▒▒▒▒▒ ▒▒  ▒▒ ▒   ▒▒  ▒▒▒▒  ▒▒▒▒▒▒  ▒▒▒▒   ▒▒▒▒  ▒   ▒▒  ▒▒▒▒  #
# ▒▒     ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ ▒ ▒▒ ▒   ▒▒   ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ #
# ▒▒     ▒▒  ▒▒ ▒▒▒ ▒▒ ▒▒       ▒▒     ▒▒   ▒▒  ▒▒ ▒▒▒ ▒▒  ▒▒    #
# ▒▒▒▒▒  ▒▒  ▒▒ ▒▒▒▒▒▒ ▒▒       ▒▒     ▒▒   ▒▒  ▒▒ ▒▒▒▒▒▒   ▒▒   #
# ▒▒     ▒▒  ▒▒ ▒▒ ▒▒▒ ▒▒       ▒▒     ▒▒   ▒▒  ▒▒ ▒▒ ▒▒▒    ▒▒  #
# ▒▒     ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒   ▒▒     ▒▒   ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ #
# ▒▒      ▒▒▒▒  ▒▒   ▒  ▒▒▒▒   ▒▒▒▒   ▒▒▒▒   ▒▒▒▒  ▒▒   ▒  ▒▒▒▒  #
#                                                                #
##################################################################
function zipme($file,$exclude='*\.zip'){
    if (is_file($file)){
        header("Location: ".$file);
        exit;
    }
    $zip=new zip(); 
    $zip->listFiles('./',$exclude);    
    $zip->create('./',$file);
    $zip->download();
    exit;
}
function onlytext($string_or_array){
	if (is_string($string_or_array)){
		return preg_replace('#[^a-zA-Z]#','',$string_or_array);
	}
	if (is_array($string_or_array)){
		return array_map('onlytext', $string_or_array);
	}
}
function txt2pic($txt,$w,$fontfile,$fontsize,$maxwidth,$wrapstring="\n"){
	$txt=filter_var($txt,FILTER_SANITIZE_STRING);

	$txt=wordwrap($txt,$w,$wrapstring);
	$textbox=imagettfbbox($fontsize, 0, $fontfile, $txt);
	$texte_w=$textbox[2];
	$texte_h=$textbox[3]+abs($textbox[5]);
	$txt_picture = @imagecreatetruecolor($texte_w, $texte_h) or die ("Erreur lors de la création de l'image");
	$color=imagecolorallocate( $txt_picture , 0,0,0);
	$background_color=imagecolorallocate( $txt_picture , 255,255,255);
	imagefill($txt_picture, 1,1, $background_color);
	imagettftext($txt_picture,$fontsize,0,2,0,$color,$fontfile,$txt);
	return ['picture'=>$txt_picture,'w'=>$texte_w,'h'=>$texte_h];
}
function doGrid($size,$mots,$horizontal,$capitalForWordsOnly=false,$reverse=false){
	# tirage de la grille
	$mots=preg_replace('#[^a-zA-Z,]#','',$mots);
	$grid=new grid($mots,$size);
	$grid->setHorizontalOnly($horizontal);
	$grid->setCapitalForWordsOnly($capitalForWordsOnly);
	$grid->setReverse($reverse);
	$grid->placeWords();
	return $grid;
}
########################
#                      #
#  ▒▒▒▒  ▒▒▒▒▒▒ ▒▒▒▒▒▒ #
# ▒▒  ▒▒ ▒▒     ▒ ▒▒ ▒ #
# ▒▒     ▒▒       ▒▒   #
# ▒▒ ▒▒▒ ▒▒▒▒▒    ▒▒   #
# ▒▒  ▒▒ ▒▒       ▒▒   #
# ▒▒  ▒▒ ▒▒       ▒▒   #
#  ▒▒▒▒  ▒▒▒▒▒▒  ▒▒▒▒  #
#                      #
########################

if (isset($_GET['help'])){	
	exit(nl2br(file_get_contents('readme.html')));
}

if (isset($_GET['version'])){	
	exit(VERSION);
}
if (isset($_GET['download'])){	
	zipme('MomelAPI_v'.VERSION.'.zip','.\.zip|.rendered\/.');
}
if (isset($_GET['picslist'])){
	$picslist=glob('rendered/*.jpg');
	if (!isset($_GET['random'])){
		$picslist=array_map('basename',$picslist);		
	}else{
		shuffle($picslist);
		$_GET['random']=intval($_GET['random']);
		if (empty($_GET['random'])){
			exit($picslist[0]);
		}
		$picslist=array_slice($picslist,0, $_GET['random']);
	}
	if (!isset($_GET['gallery'])){
		exit(json_encode($picslist));
	}else{
		echo '<style>img{display:block;width:100%;height:auto;}</style><div style="display:grid;grid-template-columns: repeat(auto-fit, minmax(256px, 1fr));
			">';
		foreach ($picslist as $pic) {
			echo '<img src="rendered/'.$pic.'"/>';
		}
		echo '</div>';
	}
	
}


if (!empty($_GET['output'])&&$_GET['output']=='text'){
	$extension='txt';
}elseif (!empty($_GET['output'])&&$_GET['output']=='json'){
	$extension='json';
}else{
	$extension='jpg';
}


if (!empty($_GET['mots'])){
	# Si la taille de la grille est précisée
	if (!empty($_GET['size'])&&filter_var($_GET['size'],FILTER_VALIDATE_INT)){
		$size=intval($_GET['size']);
	}else{
		$size=TAILLE_MIN_GRILLE;
	}

	$filename=hash('sha1', $_SERVER['QUERY_STRING']).'.'.$extension;
	$generated_grid_file_path='rendered/'.$filename;

	# Charge le fichier tampon
	if (is_file($generated_grid_file_path) && !isset($_GET['force'])){
		if ($extension=='json'){
			header ("Content-type: application/json");
		}elseif ($extension=='txt'){
			header ("Content-type: text/plain");
		}else{
			header ("Content-type: image/jpg");
		}
		exit(file_get_contents($generated_grid_file_path));
	}

	$grid=doGrid($size,$_GET['mots'],isset($_GET['horizontal']),isset($_GET['capitalforwordsonly']),isset($_GET['reverse']));

	if ($extension=='txt'){
		# Rendu texte
		$grid->echoGrid();
		exit;

	}elseif ($extension=='json'){
		# Rendu json
		$filename.='.json';
		$txt=array_map(function($a){return str_replace(' ','',$a);},$grid->grid2lines());
		$txt=json_encode($txt);
		file_put_contents($generated_grid_file_path,$txt);
		exit($txt);

	}else{
		# Rendu image		
		$gridfontfile=glob('fonts/*'.FONTE.'*.ttf')[0];
		$txt=$grid->grid2lines();
		$grille=$grid->getGrid();
		# Génération images
		if (!empty($txt)){	
			$largeur_en_caracteres=strlen($txt[0]);
			$generated_list_picture = $generated_title_picture =['h'=>0];

			# Generation de l'image de la grille
			$size=(TAILLE_FONTE*$largeur_en_caracteres)+1;
			$generated_grid_picture = @imagecreatetruecolor($size, $size) or die ("Erreur lors de la création de l'image");
			$color=imagecolorallocate( $generated_grid_picture , 0,0,0);
			$background_color=imagecolorallocate( $generated_grid_picture , 255,255,255);
			imagefill($generated_grid_picture, 1,1, $background_color);

			foreach ($grille as $x=>$ligne) {
				foreach ($ligne as $y => $lettre) {
					$xx=$x*TAILLE_FONTE;
					imagettftext($generated_grid_picture,TAILLE_FONTE,0,($x*TAILLE_FONTE*2)+1,($y*TAILLE_FONTE*2)+TAILLE_FONTE,$color,$gridfontfile,$lettre);
				}
			}

			# Generation de l'image du titre (si demandée)
			if (!empty($_GET['title'])){
				$titlefontfile=glob('fonts/*'.FONTE_TEXTE.'*.ttf')[0];
				$title=filter_var($_GET['title'],FILTER_SANITIZE_STRING);
				$generated_title_picture =txt2pic("\n".$title."\n ",$largeur_en_caracteres,$titlefontfile,TAILLE_FONTE,$size,"\n\n");
			}

			# Generation de l'image de la liste de mots (si demandée)
			if (isset($_GET['list'])){
				if (!empty($_GET['list'])&&$_GET['list']!='on'){
					$list=filter_var($_GET['list'],FILTER_SANITIZE_STRING);	
				}else{
					$list=$_GET['mots'];
				}
					
				$generated_list_picture = txt2pic("\n\n".str_replace(',',' ',$list)."\n",$largeur_en_caracteres,$gridfontfile,TAILLE_FONTE,$size);	
			}

			
			

			# Merge des images générées si elles ont été demandées
			$new_height=$generated_title_picture['h']+$generated_list_picture['h'];
			if (!empty($new_height)){
				$final_picture= @imagecreatetruecolor($size,$new_height+$size) or die ("Erreur lors de la création de l'image");
				$background_color=imagecolorallocate( $generated_grid_picture , 255,255,255);
				imagefill($final_picture, 1,1, $background_color);
		
				$grid_y=0;

				if (!empty($generated_title_picture['picture'])){	
					imagecopy($final_picture, $generated_title_picture['picture'], ($size-$generated_title_picture['w'])/2, 0, 0, 0, $generated_title_picture['w'], $generated_title_picture['h']);
					$grid_y=$generated_title_picture['h'];
				}
				if (!empty($generated_list_picture['picture'])){	
					imagecopy($final_picture, $generated_list_picture['picture'],  ($size-$generated_list_picture['w'])/2, $grid_y+$size, 0, 0, $generated_list_picture['w'], $generated_list_picture['h']);
				}
				imagecopy($final_picture, $generated_grid_picture, 0, $grid_y, 0, 0, $size, $size);
				$generated_grid_picture=$final_picture;
			}

			
			header ("Content-type: image/jpg");
			
			if (!isset($_GET['dontsave'])){			
				imagejpeg($generated_grid_picture,$generated_grid_file_path,100);
				exit(file_get_contents($generated_grid_file_path));
			}else{
				imagejpeg($generated_grid_picture,null,100);
			}
			exit;
		}
	}



}

include('frontend.php');
