<?php 
########################################
#                                      #
# █     █  ████  █     █ ██████ ████   #
# ██   ██ ██  ██ ██   ██ ██      ██    #
# ███ ███ ██  ██ ███ ███ ██      ██    #
# ███████ ██  ██ ███████ █████   ██    #
# ██ █ ██ ██  ██ ██ █ ██ ██      ██    #
# ██   ██ ██  ██ ██   ██ ██      ██ ██ #
# ██   ██  ████  ██   ██ ██████ ██████ #
#                                      #
######################################## 

########################
#                      #
#  ▒▒▒▒  ▒   ▒▒  ▒▒▒▒  #
#   ▒▒   ▒▒  ▒▒   ▒▒   #
#   ▒▒   ▒▒▒ ▒▒   ▒▒   #
#   ▒▒   ▒▒▒▒▒▒   ▒▒   #
#   ▒▒   ▒▒ ▒▒▒   ▒▒   #
#   ▒▒   ▒▒  ▒▒   ▒▒   #
#  ▒▒▒▒  ▒▒   ▒  ▒▒▒▒  #
#                      #
########################

define('FONTE','courrier');
define('TAILLE_FONTE',32);
define('TAILLE_MIN_GRILLE',15);
define('VERSION','1.0');


##################################################################
#                                                                #
# ▒▒▒▒▒▒ ▒▒  ▒▒ ▒   ▒▒  ▒▒▒▒  ▒▒▒▒▒▒  ▒▒▒▒   ▒▒▒▒  ▒   ▒▒  ▒▒▒▒  #
# ▒▒     ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ ▒ ▒▒ ▒   ▒▒   ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ #
# ▒▒     ▒▒  ▒▒ ▒▒▒ ▒▒ ▒▒       ▒▒     ▒▒   ▒▒  ▒▒ ▒▒▒ ▒▒  ▒▒    #
# ▒▒▒▒▒  ▒▒  ▒▒ ▒▒▒▒▒▒ ▒▒       ▒▒     ▒▒   ▒▒  ▒▒ ▒▒▒▒▒▒   ▒▒   #
# ▒▒     ▒▒  ▒▒ ▒▒ ▒▒▒ ▒▒       ▒▒     ▒▒   ▒▒  ▒▒ ▒▒ ▒▒▒    ▒▒  #
# ▒▒     ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒   ▒▒     ▒▒   ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ #
# ▒▒      ▒▒▒▒  ▒▒   ▒  ▒▒▒▒   ▒▒▒▒   ▒▒▒▒   ▒▒▒▒  ▒▒   ▒  ▒▒▒▒  #
#                                                                #
##################################################################
function onlytext($string_or_array){
	if (is_string($string_or_array)){
		return preg_replace('#[^a-zA-Z]#','',$string_or_array);
	}
	if (is_array($string_or_array)){
		return array_map('onlytext', $string_or_array);
	}
}
########################
#                      #
#  ▒▒▒▒  ▒▒▒▒▒▒ ▒▒▒▒▒▒ #
# ▒▒  ▒▒ ▒▒     ▒ ▒▒ ▒ #
# ▒▒     ▒▒       ▒▒   #
# ▒▒ ▒▒▒ ▒▒▒▒▒    ▒▒   #
# ▒▒  ▒▒ ▒▒       ▒▒   #
# ▒▒  ▒▒ ▒▒       ▒▒   #
#  ▒▒▒▒  ▒▒▒▒▒▒  ▒▒▒▒  #
#                      #
########################

if (isset($_GET['help'])){	
	exit(nl2br(file_get_contents('readme.html')));
}

if (isset($_GET['version'])){	
	exit(VERSION);
}
if (isset($_GET['download'])){	
	header('Content-Type: application/octet-stream');
    header('Content-Length: '.filesize('index.php'));
    header('Content-disposition: attachment; filename=index.php');
    header('Pragma: no-cache');
    header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
    header('Expires: 0');
    readfile('index.php');
    exit();
}

if (isset($_GET['picslist'])){
	$picslist=glob('rendered/*');
	if (!isset($_GET['random'])){
		$picslist=array_map('basename',$picslist);		
	}else{
		shuffle($picslist);
		$_GET['random']=intval($_GET['random']);
		if (empty($_GET['random'])){
			exit($picslist[0]);
		}
		$picslist=array_slice($picslist,0, $_GET['random']);
	}
	if (!isset($_GET['gallery'])){
		exit(json_encode($picslist));
	}else{
		echo '<style>img{display:block;width:100%;height:auto;}</style><div style="display:grid;grid-template-columns: repeat(auto-fit, minmax(256px, 1fr));
			">';
		foreach ($picslist as $pic) {
			echo '<img src="rendered/'.$pic.'"/>';
		}
		echo '</div>';
	}
	
}

if (!empty($_GET['mots'])){

	$filename=hash('sha1', $_SERVER['QUERY_STRING']).'.jpg';
	$generated_picture_path='rendered/'.$filename;
	# ne pas régénérer les images déjà générées
	if (is_file($generated_picture_path) && !isset($_GET['force'])){
		header ("Content-type: image/jpg");
		exit(file_get_contents($generated_picture_path));
	}

	$fontfile=glob('fonts/*'.FONTE.'*.ttf')[0];
	$_GET['mots']=preg_replace('#[^a-zA-Z,]#','',$_GET['mots']);
	$mots= explode(',',strtoupper($_GET['mots']));
	$longueur_max_mots=0;
	foreach ($mots as $mot) {$longueur_max_mots=max($longueur_max_mots,strlen($mot));}

	define('CASES_PAR_COTE',max( count($mots)+2 , $longueur_max_mots+2 , TAILLE_MIN_GRILLE));
	define('TAILLE_GRILLE',CASES_PAR_COTE*CASES_PAR_COTE);
	$ligne=1;
	$grille=randomLettersGrid(CASES_PAR_COTE);
	$lignes_libres=array_fill(0,CASES_PAR_COTE , true);
	define('HORIZONTAL_ONLY',isset($_GET['horizontal']));
	
	
	# Répartition des mots dans la grille
	foreach ($mots as $mot) {
		# orientation du mot 
		$orientation=HORIZONTAL_ONLY?0:rand(0,1);
		$ligne_courante=array_rand($lignes_libres);
		placeMotSurLigne($mot,$ligne_courante);
		unset($lignes_libres[$ligne_courante]);
	}
	$txt=[];
	foreach ($grille as $ligne) {
		$txt[]=implode(' ',$ligne);
	}

	if (isset($_GET['words'])){
		//$txt[]=str_replace(',',"\n",$_GET['mots']);
	}
	

	if (!empty($mots)){		
		
		$textbox=imagettfbbox(TAILLE_FONTE, 0, $fontfile, implode("\n",$txt));
		$size=max($textbox[2], $textbox[3]);
		$generated_picture = @imagecreatetruecolor($size, $size) or die ("Erreur lors de la création de l'image");
		$color=imagecolorallocate( $generated_picture , 0,0,0);
		$background_color=imagecolorallocate( $generated_picture , 255,255,255);
		imagefill($generated_picture, 1,1, $background_color);

		# text
		foreach ($grille as $index=>$ligne) {
			imagettftext($generated_picture,TAILLE_FONTE,0,0,$index*(TAILLE_FONTE*2)+TAILLE_FONTE,$color,$fontfile,implode(' ',$ligne));
		}
		

		if (error_get_last ( )){exit;}
		header ("Content-type: image/jpg");
		
		if (!isset($_GET['dontsave'])){			
			imagejpeg($generated_picture,$generated_picture_path,100);
			exit(file_get_contents($generated_picture_path));
		}else{
			imagejpeg($generated_picture,null,100);
		}
		exit;
	}

}

function placeMotSurLigne($mot,$ligne){
	global $grille;
	$len=strlen($mot);
	$premiere_case=rand(1,CASES_PAR_COTE-$len);
	
	for($case=0;$case<$len ;$case++) {
		$grille[$ligne][$case+$premiere_case]=$mot[$case];
	}
		
}

function getPatternLine($line){
	global $grille;
	$pattern='';
	foreach ($grille[$ligne] as $key => $value) {
		if (!$value){
			$pattern.='.*';
		}else{
			$pattern.=$value;
		}
	}
	return $pattern;
}
function wordMatchPattern($mot,$ligne){
	return preg_match(getPatternLine($ligne), $mot);
}
function randomLettersGrid($nb){
	$str=[];
	for($i=1;$i<=$nb;$i++){
		$str[]=randomString($nb);
	}
	return $str;
}
function randomString($nb){
	$str=[];
	for($i=1;$i<=$nb;$i++){
		$str[]=chr(rand(65,90));
	}
	return $str;
}
include('frontend.php');
